from twisted.internet.defer import DeferredList
from twisted.internet import reactor


def command(options):
    """
    Bootstrap all machine providers in all configured environments.
    """
    actions = []

    for environment_name in options.environments.get_names():
        environment = options.environments.get(environment_name)
        provider = environment.get_machine_provider()
        actions.append(provider.bootstrap())

    return DeferredList(actions).addBoth(lambda result: reactor.stop())
