import os

BOOTSTRAP_PACKAGES = [
    "bzr",
    "default-jre-headless",
    "zookeeper",
    "zookeeperd"]

DEFAULT_REPOSITORIES = [
    "ppa:ensemble/ppa"]

DEFAULT_PACKAGES = [
    "bzr",
    "python-setuptools",
    "python-twisted",
    "python-argparse",
    "python-txaws",
    "python-zookeeper"]


def get_user_public_key(config):
    """
    Locate a public key for the user. Either one explicitly passed
    in or one in the user's .ssh directory.

    @raise LookupError: Raised if a public ssh key is not found.
    """
    key_names = ["id_dsa.pub", "id_rsa.pub", "identity.pub"]
    if config.get("ssh_public_key"):
        key_names[:] = [config.get("ssh_public_key")]
    for key_path in key_names:
        key_path = "~/.ssh/%s" % key_path
        key_path = os.path.expanduser(key_path)
        if os.path.exists(key_path):
            return open(key_path).read()
    raise LookupError("SSH public key not found in ~/.ssh")
