from twisted.internet.defer import succeed, fail


class MachineProvider(object):

    def __init__(self, environment_name, config):
        self.environment_name = environment_name
        self.config = config

    def connect(self):
        """Connect to the zookeeper ensemble running in the machine provider"""
        return fail(NotImplementedError("Dummy Provider"))

    def list_machines(self):
        """List all the machine running in the provider."""
        return succeed([])

    def start_machine(self):
        """Start a machine in the provider."""
        return succeed([])

    def bootstrap(self):
        """
        Bootstrap ensemble on the machine provider.
        """
        return succeed([])

    def shutdown(self):
        """
        Terminate any machine resources associated to the provider.
        """
        return succeed([])

    def shutdown_machine(self, machine):
        """Terminate the given machine"""
        return fail(SyntaxError("Machine not from provider"))

    def save_state(self, state):
        """Save the state to the provider."""
        return succeed(None)

    def load_state(self):
        """Load the state from the provider."""
        return succeed({})
