from ensemble.lib.testing import TestCase
from ensemble.providers.ec2.files import FileStorage
from .common import EC2TestMixin


class ProviderTestCase(EC2TestMixin, TestCase):

    def test_provider_attributes(self):
        """
        The provider environment name and config should be available as
        parameters in the provider.
        """
        self.mocker.replay()
        provider = self.get_provider()
        self.assertEqual(provider.environment_name, self.env_name)
        self.assertEqual(provider.config.get("type"), "ec2")

    def test_get_file_storage(self):
        """The file storage is accessible via the machine provider."""
        self.mocker.replay()
        provider = self.get_provider()
        storage = provider.get_file_storage()
        self.assertTrue(isinstance(storage, FileStorage))
