from twisted.internet.defer import inlineCallbacks

import zookeeper

from txzookeeper import ZookeeperClient
from txzookeeper.tests.utils import deleteTree

from ensemble.lib.testing import TestCase
from ensemble.formula.tests.test_directory import sample_directory
from ensemble.formula.directory import FormulaDirectory


class StateTestBase(TestCase):

    @inlineCallbacks
    def setUp(self):
        zookeeper.set_debug_level(0)
        self.formula = FormulaDirectory(sample_directory)
        self.client = ZookeeperClient("localhost:2181")

        yield self.client.connect()
        yield self.client.create("/formulas")
        yield self.client.create("/services")
        yield self.client.create("/machines")

    def tearDown(self):
        deleteTree(handle=self.client.handle)
        self.client.close()
